/*! t3 v 1.1.1*/
/*!
Copyright 2015 Box, Inc. All rights reserved.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
window.Box=window.Box||{};Box.EventTarget=function(){"use strict";function EventTarget(){this._handlers={}}EventTarget.prototype={constructor:EventTarget,on:function(type,handler){if(typeof this._handlers[type]==="undefined"){this._handlers[type]=[]}this._handlers[type].push(handler)},fire:function(type,data){var handlers,i,len,event={type:type,data:data};handlers=this._handlers[event.type];if(handlers instanceof Array){handlers=handlers.concat();for(i=0,len=handlers.length;i<len;i++){handlers[i].call(this,event)}}},off:function(type,handler){var handlers=this._handlers[type],i,len;if(handlers instanceof Array){for(i=0,len=handlers.length;i<len;i++){if(handlers[i]===handler){handlers.splice(i,1);break}}}}};return EventTarget}();Box.Context=function(){"use strict";function Context(application,element){this.application=application;this.element=element}Context.prototype={broadcast:function(name,data){this.application.broadcast(name,data)},getService:function(serviceName){return this.application.getService(serviceName)},getConfig:function(name){return this.application.getModuleConfig(this.element,name)},getGlobal:function(name){return this.application.getGlobal(name)},getGlobalConfig:function(name){return this.application.getGlobalConfig(name)},reportError:function(exception){this.application.reportError(exception)},getElement:function(){return this.element}};return Context}();Box.Application=function(){"use strict";var MODULE_SELECTOR="[data-module]";var globalConfig={},modules={},serviceStack=[],services={},behaviors={},instances={},exports=[],initialized=false,application=new Box.EventTarget;var eventTypes=["click","mouseover","mouseout","mousedown","mouseup","mouseenter","mouseleave","keydown","keyup","submit","change","contextmenu","dblclick","input","focusin","focusout"];function assign(receiver,supplier){for(var prop in supplier){if(supplier.hasOwnProperty(prop)){receiver[prop]=supplier[prop]}}return receiver}function bind(method,thisValue){return function(){return method.apply(thisValue,arguments)}}function indexOf(items,item){for(var i=0,len=items.length;i<len;i++){if(items[i]===item){return i}}return-1}function reset(){globalConfig={};modules={};services={};behaviors={};instances={};initialized=false;for(var i=0;i<exports.length;i++){delete application[exports[i]];delete Box.Context.prototype[exports[i]]}exports=[]}function isServiceBeingInstantiated(serviceName){for(var i=0,len=serviceStack.length;i<len;i++){if(serviceStack[i]===serviceName){return true}}return false}function error(exception){if(globalConfig.debug){throw exception}else{application.fire("error",{exception:exception})}}function captureObjectErrors(object,objectName){var propertyName,propertyValue;for(propertyName in object){propertyValue=object[propertyName];if(typeof propertyValue==="function"){object[propertyName]=function(methodName,method){return function(){var errorPrefix=objectName+"."+methodName+"() - ";try{return method.apply(this,arguments)}catch(ex){ex.name=errorPrefix+ex.name;ex.message=errorPrefix+ex.message;error(ex)}}}(propertyName,propertyValue)}}}function getModuleName(element){var moduleAttribute=element.getAttribute("data-module");if(moduleAttribute){return moduleAttribute.split(" ")[0]}return""}function isModuleElement(element){return element&&element.hasAttribute("data-module")}function isTypeElement(element){return element&&element.hasAttribute("data-type")}function callModuleMethod(instance,method){if(typeof instance[method]==="function"){instance[method].apply(instance,Array.prototype.slice.call(arguments,2))}}function getService(serviceName){var serviceData=services[serviceName];if(serviceData){if(isServiceBeingInstantiated(serviceName)){error(new ReferenceError("Circular service dependency: "+serviceStack.join(" -> ")+" -> "+serviceName));return null}serviceStack.push(serviceName);if(!serviceData.instance){serviceData.instance=serviceData.creator(application)}serviceStack.pop();return serviceData.instance}return null}function getBehaviors(instanceData){var i,behaviorNames,behaviorData,behaviorInstances=[],moduleBehaviorInstances;behaviorNames=instanceData.instance.behaviors||[];for(i=0;i<behaviorNames.length;i++){if(!("behaviorInstances"in instanceData)){instanceData.behaviorInstances={}}moduleBehaviorInstances=instanceData.behaviorInstances;behaviorData=behaviors[behaviorNames[i]];if(behaviorData){if(!moduleBehaviorInstances[behaviorNames[i]]){moduleBehaviorInstances[behaviorNames[i]]=behaviorData.creator(instanceData.context)}behaviorInstances.push(moduleBehaviorInstances[behaviorNames[i]])}else{error(new Error('Behavior "'+behaviorNames[i]+'" not found'))}}return behaviorInstances}function getNearestTypeElement(element){var found=isTypeElement(element);while(!found&&!isModuleElement(element)){element=element.parentNode;found=isTypeElement(element)}return found?element:null}function bindEventType(element,type,handlers){function eventHandler(event){var targetElement=getNearestTypeElement(event.target),elementType=targetElement?targetElement.getAttribute("data-type"):"";for(var i=0;i<handlers.length;i++){handlers[i](event,targetElement,elementType)}return true}$(element).on(type,eventHandler);return eventHandler}function bindEventListeners(instanceData){var i,j,type,eventHandlerName,eventHandlerFunctions,moduleBehaviors=getBehaviors(instanceData);for(i=0;i<eventTypes.length;i++){eventHandlerFunctions=[];type=eventTypes[i];eventHandlerName="on"+type;if(instanceData.instance[eventHandlerName]){eventHandlerFunctions.push(bind(instanceData.instance[eventHandlerName],instanceData.instance))}for(j=0;j<moduleBehaviors.length;j++){if(moduleBehaviors[j][eventHandlerName]){eventHandlerFunctions.push(bind(moduleBehaviors[j][eventHandlerName],moduleBehaviors[j]))}}if(eventHandlerFunctions.length){instanceData.eventHandlers[type]=bindEventType(instanceData.element,type,eventHandlerFunctions)}}}function unbindEventListeners(instanceData){for(var type in instanceData.eventHandlers){if(instanceData.eventHandlers.hasOwnProperty(type)){$(instanceData.element).off(type,instanceData.eventHandlers[type])}}instanceData.eventHandlers={}}function getInstanceDataByElement(element){return instances[element.id]}return assign(application,{init:function(params){assign(globalConfig,params||{});this.startAll(document.documentElement);this.fire("init");initialized=true},destroy:function(){this.stopAll(document.documentElement);reset()},isStarted:function(element){var instanceData=getInstanceDataByElement(element);return typeof instanceData==="object"},start:function(element){var moduleName=getModuleName(element),moduleData=modules[moduleName],instanceData,context,module;if(!moduleData){error(new Error('Module type "'+moduleName+'" is not defined.'));return}if(!this.isStarted(element)){if(!element.id){element.id="mod-"+moduleName+"-"+moduleData.counter}moduleData.counter++;context=new Box.Context(this,element);module=moduleData.creator(context);if(!globalConfig.debug){captureObjectErrors(module,moduleName)}instanceData={moduleName:moduleName,instance:module,context:context,element:element,eventHandlers:{}};bindEventListeners(instanceData);instances[element.id]=instanceData;callModuleMethod(instanceData.instance,"init");var moduleBehaviors=getBehaviors(instanceData),behaviorInstance;for(var i=0,len=moduleBehaviors.length;i<len;i++){behaviorInstance=moduleBehaviors[i];callModuleMethod(behaviorInstance,"init")}}},stop:function(element){var instanceData=getInstanceDataByElement(element);if(!instanceData){if(globalConfig.debug){error(new Error("Unable to stop module associated with element: "+element.id));return}}else{unbindEventListeners(instanceData);var moduleBehaviors=getBehaviors(instanceData);var behaviorInstance;for(var i=moduleBehaviors.length-1;i>=0;i--){behaviorInstance=moduleBehaviors[i];callModuleMethod(behaviorInstance,"destroy")}callModuleMethod(instanceData.instance,"destroy");delete instances[element.id]}},startAll:function(root){var moduleElements=root.querySelectorAll(MODULE_SELECTOR);for(var i=0,len=moduleElements.length;i<len;i++){this.start(moduleElements[i])}},stopAll:function(root){var moduleElements=root.querySelectorAll(MODULE_SELECTOR);for(var i=0,len=moduleElements.length;i<len;i++){this.stop(moduleElements[i])}},addModule:function(moduleName,creator){if(typeof modules[moduleName]!=="undefined"){error(new Error("Module "+moduleName+" has already been added."));return}modules[moduleName]={creator:creator,counter:1}},getModuleConfig:function(element,name){var instanceData=getInstanceDataByElement(element),configElement;if(instanceData){if(!instanceData.config){configElement=element.querySelector('script[type="text/x-config"]');if(configElement){instanceData.config=JSON.parse(configElement.text)}}if(!instanceData.config){return null}else if(typeof name==="undefined"){return instanceData.config}else if(name in instanceData.config){return instanceData.config[name]}else{return null}}return null},addService:function(serviceName,creator,options){if(typeof services[serviceName]!=="undefined"){error(new Error("Service "+serviceName+" has already been added."));return}options=options||{};services[serviceName]={creator:creator,instance:null};if(options.exports){var i,length=options.exports.length;for(i=0;i<length;i++){var exportedMethodName=options.exports[i];var handler=function(methodName){return function(){var service=getService(serviceName);return service[methodName].apply(service,arguments)}}(exportedMethodName);if(exportedMethodName in this){error(new Error(exportedMethodName+" already exists on Application object"));return}else{this[exportedMethodName]=handler}if(exportedMethodName in Box.Context.prototype){error(new Error(exportedMethodName+" already exists on Context prototype"));return}else{Box.Context.prototype[exportedMethodName]=handler}exports.push(exportedMethodName)}}},getService:getService,addBehavior:function(behaviorName,creator){if(typeof behaviors[behaviorName]!=="undefined"){error(new Error("Behavior "+behaviorName+" has already been added."));return}behaviors[behaviorName]={creator:creator,instance:null}},broadcast:function(name,data){var i,id,instanceData,behaviorInstance,moduleBehaviors,messageHandlers;for(id in instances){if(instances.hasOwnProperty(id)){messageHandlers=[];instanceData=instances[id];if(indexOf(instanceData.instance.messages||[],name)!==-1){messageHandlers.push(bind(instanceData.instance.onmessage,instanceData.instance))}moduleBehaviors=getBehaviors(instanceData);for(i=0;i<moduleBehaviors.length;i++){behaviorInstance=moduleBehaviors[i];if(indexOf(behaviorInstance.messages||[],name)!==-1){messageHandlers.push(bind(behaviorInstance.onmessage,behaviorInstance))}}for(i=0;i<messageHandlers.length;i++){messageHandlers[i](name,data)}}}},getGlobal:function(name){if(name in window){return window[name]}else{return null}},getGlobalConfig:function(name){if(typeof name==="undefined"){return globalConfig}else if(name in globalConfig){return globalConfig[name]}else{return null}},setGlobalConfig:function(config){if(initialized){error(new Error("Cannot set global configuration after application initialization"));return}for(var prop in config){if(config.hasOwnProperty(prop)){globalConfig[prop]=config[prop]}}},reportError:error})}();
//# sourceMappingURL=./dist/t3.min.js.map
